%define debug_package %{nil}
%global pkg mpt3sas
%global kernel 5.10.134-17.an8
%define pkg_version 47.00.00.00
%define anolis_release 6

%define kmod_kernel_version	%{kernel}.%{_arch}
%global kernel_source 	        /usr/src/kernels/%{kmod_kernel_version}
%define sbindir 		%( if [ -d "/sbin" -a \! -h "/sbin" ]; then echo "/sbin"; else echo %{_sbindir}; fi )
%define dup_state_dir 		%{_localstatedir}/lib/rpm-state/kmod-dups
%define kver_state_dir 		%{dup_state_dir}/kver
%define kver_state_file 	%{kver_state_dir}/%{kmod_kernel_version}
%define dup_module_list 	%{dup_state_dir}/rpm-kmod-%{pkg}-modules

Name:			kmod-%{pkg}
Version:		%(echo %{kernel} | sed -E 's/-/~/g; s/\.(an|al)[0-9]+$//g')
Release:		%{pkg_version}~%{anolis_release}%{?dist}
Summary:		%{pkg} kernel module(s)
Group:			System/Kernel
License:		GPLv2
URL:			http://www.lsilogic.com
Distribution:		LSI Corporation
Source0:		kmod-%{pkg}-%{pkg_version}.tar.gz
BuildRoot:		%(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
#Provides:		kernel-modules >= %{kmod_kernel_version}
Provides:		kmod-%{pkg} = %{?epoch:%{epoch}:}%{version}-%{release}

BuildRequires:          kernel-devel = %{kernel}
BuildRequires:          kernel-core = %{kernel}
BuildRequires:          elfutils-libelf-devel

Requires(post):		%{sbindir}/weak-modules
Requires(post):		%{sbindir}/depmod 
Requires(postun):       %{sbindir}/depmod 
Requires(postun):	%{sbindir}/weak-modules
Requires(posttrans):    %{_bindir}/sort
Requires(postun):       %{_bindir}/sort
%define __strip /bin/true

%description
LSI MPT Fusion HBA drivers (12gb SAS)

This package provides the mpt3sas kernel modules built for
the Linux kernel %{kmod_kernel_version} for the x86_64
family of processors.
The GPG Public Key of digitally signed Broadcom DCSG drivers is located in:
https://docs.broadcom.com/docs/dcsg-gpg-verification-guide

%post
if [ -e "/boot/System.map-%{kmod_kernel_version}" ]; then
	%{sbindir}/depmod -aeF "/boot/System.map-%{kmod_kernel_version}" "%{kmod_kernel_version}" > /dev/null || :
fi
modules=( $(find /lib/modules/%{kmod_kernel_version}/extra/drivers/scsi/%{pkg} | grep '\.ko$') )

mkdir -p "%{kver_state_dir}"
touch "%{kver_state_file}"

depmod -a > /dev/null 2>&1

if [ -x "/usr/sbin/weak-modules" ]; then
    printf '%s\n' "${modules[@]}" | /usr/sbin/weak-modules --no-initramfs --add-modules
fi

%preun
mkdir -p "%{dup_state_dir}"
rpm -ql kmod-%{pkg}| \
	grep '\.ko$' > "%{dup_module_list}"

%postun
if [ -e "/boot/System.map-%{kmod_kernel_version}" ]; then
	%{sbindir}/depmod -aeF "/boot/System.map-%{kmod_kernel_version}" "%{kmod_kernel_version}" > /dev/null || :
fi
modules=( $(cat "%{dup_module_list}") )
rm -f "%{dup_module_list}"
printf '%s\n' "${modules[@]}" | %{sbindir}/weak-modules --remove-modules

rmdir "%{dup_state_dir}" 2> /dev/null

exit 0

%files
%defattr(644,root,root,755)
/lib/modules/%{kmod_kernel_version}
/etc/depmod.d/%{pkg}.conf
/etc/dracut.conf.d/%{pkg}.conf
%license licenses/GPL_license.txt

%prep
%setup -n kmod-%{pkg}-%{pkg_version}

%build
make -C  %{kernel_source} M=$PWD/src
# mark modules executable so that strip-to-file can strip them
#find obj -name "*.ko" -type f -exec chmod u+x '{}' +
whitelist="/lib/modules/kabi-current/kabi_whitelist_%{_target_cpu}"

%install
mkdir -p %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra/drivers/scsi/%{pkg}

export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=extra/drivers/scsi/%{pkg}
make -C %{kernel_source} modules_install M=$PWD/src 
# Cleanup unnecessary kernel-generated module dependency files.
find $INSTALL_MOD_PATH/lib/modules -iname 'modules.*' -exec rm {} \;

install -m 644 -D  %{pkg}.conf  $RPM_BUILD_ROOT/etc/depmod.d/%{pkg}.conf
install -m 644 -D dracut-%{pkg}.conf $RPM_BUILD_ROOT/etc/dracut.conf.d/%{pkg}.conf

# Make .ko objects temporarily executable for automatic stripping
find %{buildroot}/lib/modules -type f -name \*.ko -exec chmod u+x \{\} \+

# Generate depmod.conf
%{__install} -d %{buildroot}/%{_sysconfdir}/depmod.d/
for kmod in $(find %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra -type f -name \*.ko -printf "%%P\n" | sort)
do
    echo "override $(basename $kmod .ko) * weak-updates/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}.conf
    echo "override $(basename $kmod .ko) * extra/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}.conf
done

%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Fri Jul 19 2024 daichx <daichx@inspur.com> - 47.00.00.00
- init 47.00.00.00
